PASSED_MSG="OK"
TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"
PASSED_MSG="OK"
NUMBER_OF_STEPS=1
CURRENT_STEP=0
COUNT_PASSED_TEST=0

if [[ -p /tmp/my_fifo ]]; then
	unlink /tmp/my_fifo
fi

strace -e mknod,read,write -o $STRACE_OUTPUT ./u2_1 test

echo "TESTOVANIE"
((CURRENT_STEP+=1))
echo $CURRENT_STEP"/3 Testovanie zavolania sluzby semget()"
if grep -q "^mknod(\"/tmp/my_fifo\",[[:space:]]*S_IFIFO[[:space:]]*|[[:space:]]*0777)" $STRACE_OUTPUT; then
	echo "OK - Sluzba mkfifo() bola zavolana so spravnymi parametrami."
else
	echo "CHYBA - Sluzba mkfifo() nebola zavolana alebo jej boli zadane nespravne parametre."
fi


((CURRENT_STEP+=1))
echo $CURRENT_STEP"/3 Testovanie zapisu do rury"
if grep -q "^write(3, \"test" $STRACE_OUTPUT; then
	echo "OK - Sluzba write() bola zavolana so spravnymi parametrami."
	((COUNT_PASSED_TEST+=1))
else
	echo "CHYBA - Sluzba write() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo $CURRENT_STEP"/3 Testovanie citania z rury"
if grep -q "^read(3, \"test" $STRACE_OUTPUT; then
	echo "OK - Sluzba read() bola zavolana so spravnymi parametrami."
	((COUNT_PASSED_TEST+=1))
else
	echo "CHYBA - Sluzba read() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

echo ""
echo "Vysledok testovania"
echo "Uspesne bolo vykonanych "$COUNT_PASSED_TEST"/"$CURRENT_STEP" testov."
echo ""

if [[ -p /tmp/my_fifo ]]; then
	unlink /tmp/my_fifo
fi
